/*	$NetBSD: grf_conf.c,v 1.3 1996/02/24 00:55:08 thorpej Exp $	*/

/*
 * Copyright (c) 1996 Jason R. Thorpe.  All rights reserved.
 * Copyright (c) 1991 University of Utah.
 * Copyright (c) 1990, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * This code is derived from software contributed to Berkeley by
 * the Systems Programming Group of the University of Utah Computer
 * Science Department.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * from: Utah $Hdr: grf_conf.c 1.2 92/01/22$
 *
 *	@(#)grf_conf.c	8.1 (Berkeley) 6/10/93
 */

/*
 * XXX this information could be generated by config.
 */
#include "grf.h"
#if NGRF > 0

#include <sys/types.h>

#include <hp300/dev/grfioctl.h>		/* XXX */
#include <hp300/dev/grfvar.h>

extern	struct grfsw dvbox_grfsw;
extern	struct grfsw gbox_grfsw;
extern	struct grfsw hyper_grfsw;
extern	struct grfsw rbox_grfsw;
extern	struct grfsw topcat_grfsw;
extern	struct grfsw lrcatseye_grfsw;
extern	struct grfsw hrcatseye_grfsw;
extern	struct grfsw hrmcatseye_grfsw;

struct grfsw *grfsw[] = {
	&topcat_grfsw,
	&gbox_grfsw,
	&rbox_grfsw,
	&lrcatseye_grfsw,
	&hrcatseye_grfsw,
	&hrmcatseye_grfsw,
	&dvbox_grfsw,
	&hyper_grfsw,
};
int	ngrfsw = sizeof(grfsw) / sizeof(grfsw[0]);
#endif /* NGRF > 0 */
